3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [[-i | -o] <path>...]'
11 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
16 unmerged_ok_if_status=--unmerged ;;
19 unmerged_ok_if_status= ;;
24 echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
32 cp -p "$THIS_INDEX" "$NEXT_INDEX"
36 # If TMP_INDEX is defined, that means we are doing
37 # "--only" partial commit, and that index file is used
38 # to build the tree for the commit. Otherwise, if
39 # NEXT_INDEX exists, that is the index file used to
40 # make the commit. Otherwise we are using as-is commit
41 # so the regular index file is what we use to compare.
42 if test '' != "$TMP_INDEX"
44 GIT_INDEX_FILE="$TMP_INDEX"
46 elif test -f "$NEXT_INDEX"
48 GIT_INDEX_FILE="$NEXT_INDEX"
52 case "$status_only" in
56 git-runstatus ${color} \
57 ${verbose:+--verbose} \
59 ${untracked_files:+--untracked}
63 test -z "$TMP_INDEX" || {
64 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
69 ################################################################
70 # Command line argument parsing and sanity checking
89 while case "$#" in 0) break;; esac
92 -F|--F|-f|--f|--fi|--fil|--file)
93 case "$#" in 1) usage ;; esac
102 log_given=t$log_given
103 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
106 --F=*|--f=*|--fi=*|--fil=*|--file=*)
108 log_given=t$log_given
109 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
116 --au=*|--aut=*|--auth=*|--autho=*|--author=*)
117 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
120 --au|--aut|--auth|--autho|--author)
121 case "$#" in 1) usage ;; esac
126 -e|--e|--ed|--edi|--edit)
130 -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
134 -o|--o|--on|--onl|--only)
138 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
139 case "$#" in 1) usage ;; esac
141 log_given=m$log_given
142 if test "$log_message" = ''
146 log_message="$log_message
154 log_given=m$log_given
155 if test "$log_message" = ''
157 log_message=`expr "z$1" : 'z-m\(.*\)'`
159 log_message="$log_message
161 `expr "z$1" : 'z-m\(.*\)'`"
166 --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
167 log_given=m$log_given
168 if test "$log_message" = ''
170 log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
172 log_message="$log_message
174 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
179 -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
184 --a|--am|--ame|--amen|--amend)
186 log_given=t$log_given
191 case "$#" in 1) usage ;; esac
193 log_given=t$log_given
198 --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
199 --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
200 --reedit-messag=*|--reedit-message=*)
201 log_given=t$log_given
202 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
206 --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
207 --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
209 case "$#" in 1) usage ;; esac
211 log_given=t$log_given
217 case "$#" in 1) usage ;; esac
219 log_given=t$log_given
224 --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
225 --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
227 log_given=t$log_given
228 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
232 --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
233 --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
234 case "$#" in 1) usage ;; esac
236 log_given=t$log_given
241 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
245 -q|--q|--qu|--qui|--quie|--quiet)
249 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
253 -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
254 --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
255 --untracked-file|--untracked-files)
271 case "$edit_flag" in t) no_edit= ;; esac
273 ################################################################
274 # Sanity check options
276 case "$amend,$initial_commit" in
278 die "You do not have anything to amend." ;;
280 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
281 die "You are in the middle of a merge -- cannot amend."
287 die "Only one of -c/-C/-F/--amend can be used." ;;
289 die "Option -m cannot be combined with -c/-C/-F/--amend." ;;
292 case "$#,$also,$only,$amend" in
294 die "Only one of --include/--only can be used." ;;
296 die "No paths with --include/--only does not make sense." ;;
298 only_include_assumed="# Clever... amending the last one with dirty index." ;;
302 only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
307 case "$all,$also,$#" in
309 die "Cannot use -a and -i at the same time." ;;
311 die "Paths with -a does not make sense." ;;
313 die "No paths with -i does not make sense." ;;
316 ################################################################
317 # Prepare index to have a tree to be committed
321 if test ! -f "$THIS_INDEX"
323 die 'nothing to commit (use "git add file1 file2" to include for commit)'
328 GIT_INDEX_FILE="$NEXT_INDEX" &&
329 export GIT_INDEX_FILE &&
330 git-diff-files --name-only -z |
331 git-update-index --remove -z --stdin
336 git-ls-files --error-unmatch -- "$@" >/dev/null || exit
338 git-diff-files --name-only -z -- "$@" |
341 GIT_INDEX_FILE="$NEXT_INDEX" &&
342 export GIT_INDEX_FILE &&
343 git-update-index --remove -z --stdin
351 if test -f "$GIT_DIR/MERGE_HEAD"
353 refuse_partial "Cannot do a partial commit during a merge."
355 TMP_INDEX="$GIT_DIR/tmp-index$$"
356 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
358 # Build a temporary index and update the real index
360 if test -z "$initial_commit"
362 cp "$THIS_INDEX" "$TMP_INDEX"
363 GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
368 echo "$commit_only" |
369 GIT_INDEX_FILE="$TMP_INDEX" \
370 git-update-index --add --remove --stdin &&
373 echo "$commit_only" |
375 GIT_INDEX_FILE="$NEXT_INDEX"
376 export GIT_INDEX_FILE
377 git-update-index --remove --stdin
384 ################################################################
385 # If we do as-is commit, the index file will be THIS_INDEX,
386 # otherwise NEXT_INDEX after we make this commit. We leave
387 # the index as is if we abort.
389 if test -f "$NEXT_INDEX"
391 USE_INDEX="$NEXT_INDEX"
393 USE_INDEX="$THIS_INDEX"
396 GIT_INDEX_FILE="$USE_INDEX" \
397 git-update-index -q $unmerged_ok_if_status --refresh || exit
399 ################################################################
400 # If the request is status, just show it and exit.
408 ################################################################
409 # Grab commit message, write out tree and make commit.
411 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
415 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
417 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
421 if test "$log_message" != ''
424 elif test "$logfile" != ""
426 if test "$logfile" = -
429 echo >&2 "(reading log message from standard input)"
434 elif test "$use_commit" != ""
436 encoding=$(git config i18n.commitencoding || echo UTF-8)
437 git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
438 sed -e '1,/^$/d' -e 's/^ //'
439 elif test -f "$GIT_DIR/MERGE_MSG"
441 cat "$GIT_DIR/MERGE_MSG"
442 elif test -f "$GIT_DIR/SQUASH_MSG"
444 cat "$GIT_DIR/SQUASH_MSG"
445 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
449 need_blank_before_signoff=
450 tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
451 grep 'Signed-off-by:' >/dev/null || need_blank_before_signoff=yes
453 test -z "$need_blank_before_signoff" || echo
454 git-var GIT_COMMITTER_IDENT | sed -e '
458 } >>"$GIT_DIR"/COMMIT_EDITMSG
462 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
464 echo "# It looks like you may be committing a MERGE."
465 echo "# If this is not correct, please remove the file"
466 echo "# $GIT_DIR/MERGE_HEAD"
467 echo "# and try again"
469 fi >>"$GIT_DIR"/COMMIT_EDITMSG
472 if test '' != "$use_commit"
476 s/'\''/'\''\\'\'\''/g
478 s/^author \([^<]*\) <[^>]*> .*$/\1/
480 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
483 s/^author [^<]* <\([^>]*\)> .*$/\1/
485 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
488 s/^author [^<]* <[^>]*> \(.*\)$/\1/
490 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
495 encoding=$(git config i18n.commitencoding || echo UTF-8)
496 set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
497 LANG=C LC_ALL=C sed -ne "$pick_author_script"`
498 eval "$set_author_env"
499 export GIT_AUTHOR_NAME
500 export GIT_AUTHOR_EMAIL
501 export GIT_AUTHOR_DATE
503 if test '' != "$force_author"
505 GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
506 GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
507 test '' != "$GIT_AUTHOR_NAME" &&
508 test '' != "$GIT_AUTHOR_EMAIL" ||
509 die "malformed --author parameter"
510 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
514 if test -z "$initial_commit"
517 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
518 rloga='commit (merge)'
519 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
520 elif test -n "$amend"; then
521 rloga='commit (amend)'
522 PARENTS=$(git-cat-file commit HEAD |
523 sed -n -e '/^$/q' -e 's/^parent /-p /p')
525 current="$(git-rev-parse --verify HEAD)"
527 if [ -z "$(git-ls-files)" ]; then
528 echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
532 rloga='commit (initial)'
535 set_reflog_action "$rloga"
537 if test -z "$no_edit"
541 echo "# Please enter the commit message for your changes."
542 echo "# (Comment lines starting with '#' will not be included)"
543 test -z "$only_include_assumed" || echo "$only_include_assumed"
545 } >>"$GIT_DIR"/COMMIT_EDITMSG
547 # we need to check if there is anything to commit
548 run_status >/dev/null
550 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
552 rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
559 case "${VISUAL:-$EDITOR},$TERM" in
561 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
562 echo >&2 "Please supply the commit log message using either"
563 echo >&2 "-m or -F option. A boilerplate log message has"
564 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
568 git-var GIT_AUTHOR_IDENT > /dev/null || die
569 git-var GIT_COMMITTER_IDENT > /dev/null || die
570 ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
576 if test -x "$GIT_DIR"/hooks/commit-msg
578 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
582 if test -z "$no_edit"
590 ' "$GIT_DIR"/COMMIT_EDITMSG
592 cat "$GIT_DIR"/COMMIT_EDITMSG
594 git-stripspace >"$GIT_DIR"/COMMIT_MSG
596 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
601 if test -z "$TMP_INDEX"
603 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
605 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
608 commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
609 rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
610 git-update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" &&
611 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
612 if test -f "$NEXT_INDEX"
614 mv "$NEXT_INDEX" "$THIS_INDEX"
619 echo >&2 "* no commit message? aborting commit."
623 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
624 if test -d "$GIT_DIR/rr-cache"
631 if test -x "$GIT_DIR"/hooks/post-commit
633 "$GIT_DIR"/hooks/post-commit
637 echo "Created${initial_commit:+ initial} commit $commit"
638 git-diff-tree --shortstat --summary --root --no-commit-id HEAD --